<?php

/**
 * Submit search query and process search results.
 */
function winlivesearch_service($keys) {
  global $pager_page_array, $pager_total, $pager_total_items, $language;
  $limit = max(1, intval(variable_get('winlivesearch_limit', 15)));
  $pager_page_array = explode(',', isset($_GET['page']) ? $_GET['page'] : '');
  $results = array();
  $keys = variable_get('winlivesearch_query', '') ? '('. $keys .') AND ('. variable_get('winlivesearch_query', '') .')' : $keys;
  try {
    $webservice = new SoapClient('http://api.search.live.net/search.wsdl');
    if ($webservice) {
      $params = array('parameters' => array(
        'AppId' => variable_get('winlivesearch_appid', ''),
        'Market' => ((isset($language->language) && variable_get('winlivesearch_use_locale', 0)) ? $language->language : variable_get('winlivesearch_locale', 'en-US')),
        'Options' => array('SearchOption' => array('EnableHighlighting')),
        'Query' => $keys,
        'Sources' => array(variable_get('winlivesearch_source', 'Web')),
        'Adult' => variable_get('winlivesearch_safesearch', 'Strict'),
      ));
      foreach ($params['parameters']['Sources'] as $element => $source) {
        $params['parameters'][$source] = array('Count' => $limit, 'Offset' => $limit * intval($pager_page_array[$element]));
      }
      $response = $webservice->Search($params);
      $search = array('/\x{e000}/u', '/\x{e001}/u');
      $replace = array('<strong>', '</strong>');
      foreach ($params['parameters']['Sources'] as $element => $source) {
        $items = isset($response->parameters->$source->Results->{$source .'Result'}) ? $response->parameters->$source->Results->{$source .'Result'} : array();
        $items = is_array($items) ? $items : array($items);
        foreach ($items as $item) {
          // Just in case there's a XSS payload in a live search description, we run
          // check_plain().  Link and title are already filtered by l().
          $results[] = array(
            'link' => isset($item->Url) ? $item->Url : NULL,
            'snippet' => isset($item->Description) ? preg_replace($search, $replace, check_plain($item->Description)) : NULL,
            'title' => isset($item->Title) ? preg_replace($search, '', $item->Title) : NULL,
            'date' => isset($item->DateTime) ? strtotime($item->DateTime) : NULL,
            'extra' => isset($item->DisplayUrl) ? array(preg_replace($search, $replace, check_plain($item->DisplayUrl))) : NULL,
          );
        }
        $pager_total_items[$element] = min(isset($response->parameters->$source->Total) ? $response->parameters->$source->Total : 0, 1000);
        $pager_total[$element] = ceil($pager_total_items[$element] / $limit);
        $pager_page_array[$element] = max(0, min(intval($pager_page_array[$element]), intval($pager_total[$element]) - 1));
      }
    }
  }
  catch (Exception $fault) {
    drupal_set_message(t('Web service error: %faultstring.', array('%faultstring' => $fault->faultstring)), 'error');
    watchdog('winlivesearch', t('Web service error: %faultstring. <pre>%detail</pre>'), array('%faultstring' => $fault->faultstring, '%detail' => print_r($fault->detail->Errors, TRUE)), WATCHDOG_ERROR);
  }
  return $results;
}
